import { IdentityFn, MakeRequired, RSA, RSN } from "./utils";
import type { Validate } from "./validate";
declare type CallOptions<Type, Options> = Options extends RSN ? Partial<ExtraOptions<Type>> : Partial<Options & Omit<ExtraOptions<Type>, keyof Options>>;
export declare type Guard<Type, Options extends RSA = RSN> = Validate<Type> & ((options: CallOptions<Type, Options>) => Validate<Type>);
export declare type GuardOptions<Name extends keyof vality.guards, G = vality.guards[Name]> = G extends Guard<infer Type, infer Options> ? [Type, Options] : G extends (...args: any[]) => Guard<infer Type, infer Options> ? [Type, Options] : never;
declare type ExtraOptions<T> = {
    transform: IdentityFn<T>;
    default: T;
    validate: (val: T) => boolean;
};
export declare function guard<Name extends keyof vality.guards, Type extends GuardOptions<Name>[0], Options extends RSA & GuardOptions<Name>[1]>(name: Name, fn: (val: unknown, options: Partial<Options>) => Type | undefined, handleOptions?: {
    [K in keyof Options]?: (val: Type, o: NonNullable<Options[K]>, options: MakeRequired<Options, K>) => boolean;
} & Partial<ExtraOptions<Type>>, defaultOptions?: Partial<Options>): Guard<Type, Options>;
export {};
